class Slider
{
  float _val;   // .. current value
  float _value; // .. official set value, if that makes sense
  int _x;
  int _y;
  int _width;
  int _thumbSize;
  
  float _boxx;
  float _boxy;
  
  boolean _updateValueOnReleaseOnly = false;
  
  boolean _mouseDown;
  boolean _mouseDownWas;
  boolean _isOver;
  boolean _isDragging;
  int _dragXStart;

  Slider(int $x, int $y, int $width, int $thumbSize, float $value)
  {
    _x = $x;
    _y = $y;
    _width = $width;
    _thumbSize = $thumbSize;

    _val = $value;
    setValue(_val);
  }
  
  public void updateValueOnReleaseOnly(boolean $b)
  {
    _updateValueOnReleaseOnly = $b;
  }

  public float getValue()
  {
    return _value;
  }
  
  public void setValue(float $v)
  {
    _val = $v;
    if (_val > 1) _val = 1;
    if (_val < 0) _val = 0;
    
    _value = _val;
  }

  public void update()
  {
    // Biz logic
    
    _boxx = _x - (_thumbSize/2) + (_width * _val);
    _boxy = _y - (_thumbSize/2);

    _isOver = (mouseX >= _boxx && mouseX <= _boxx + _thumbSize &&
              mouseY >= _boxy && mouseY <= _boxy + _thumbSize);
    _mouseDownWas = _mouseDown;
    _mouseDown = mousePressed;
   
    if (_isOver && _mouseDown && !_mouseDownWas) 
    {
      _isDragging = true;
      _dragXStart = mouseX;
    }
      
    //
    
    if (_isDragging) 
    {
      _val = norm(mouseX,  _x, _x + _width);
      if (_val > 1) _val = 1;
      if (_val < 0) _val = 0;
    }

    if (!_mouseDown && _mouseDownWas && _isDragging) 
    {
      _isDragging = false;
      setValue(_val);
    }
      
    if (_isDragging && ! _updateValueOnReleaseOnly) 
    {
      setValue(_val);
    }
    
    draw();
  }
  
  private void draw()
  {
    stroke(96,96,96, 128);
    line(_x, _y, _x + _width, _y);
    
    stroke(0);
    
    if (_isDragging)
      fill(255,255,255, 192);
    else if (_isOver)
      fill(255,255,255, 128);
    else
      fill(255,255,255, 64);
  
    rect( _boxx, _boxy, _thumbSize, _thumbSize );
  }
}
