class Maze
{
  public Pos _startPos;
  public Pos _endPos;
  
  private int _width;
  private int _height;
  
  private boolean[][] _wallsV;
  private boolean[][] _wallsH;
  
  
  Maze(int w, int h)
  {
    _width = w;
    _height = h;
    _wallsV = new boolean[_width][_height-1];
    _wallsH = new boolean[_height][_width-1];
    
    fill(false);
  }
  
  public void fill(boolean b)
  {
    int x, y;

    // vert walls
    for (x = 0; x < _width; x++) {
      for (y = 0; y < _height-1; y++) {
        _wallsV[x][y] = b;
      }
    }
    // init horiz walls
    for (y = 0; y < _height; y++) {
      for (x = 0; x < _width-1; x++) {
        _wallsH[y][x] = b;
      }
    }
  }
  
  public void makePerimeter()
  {
    // vert walls
    for (int y = 0; y < _height-1; y++) {
      _wallsV[0][y] = true;
      _wallsV[_width-1][y] = true;
    }
    // horiz walls
    for (int x = 0; x < _width-1; x++) {
      _wallsH[0][x] = true;
      _wallsH[_height-1][x] = true;
    }
  }
  
  public void setStartPos(Pos p)
  {
    _startPos = p;  
  }
  
  public void setEndPos(Pos p)
  {
    _endPos = p;  
  }

  public int getWidth()
  {
    return _width;
  }
  
  public int getHeight()
  {
    return _height;
  }
  
  public boolean getWallV(int x, int y)
  {
    return _wallsV[x][y];
  }

  public void setWallV(int x, int y, boolean b)
  {
    _wallsV[x][y] = b;
  }
  
  public boolean getWallH(int y, int x)
  {
    return _wallsH[y][x];
  }  
  
  public void setWallH(int y, int x, boolean b)
  {
    _wallsH[y][x] = b;
  }
}  

