class MazeView3D implements IMazeView
{
  color _colVert = color(#675032);
  color _colHoriz = color(#af9761);
  color _colFloor = color(#d9cdb3);

  Maze _maze;
  float _unit = 30;
  
  MazeView3D()
  {
  }
  
  public void setMaze(Maze m)
  {
    _maze = m;
  }
  
  public float getUnitSize()
  {
    return _unit;
  }
  
  public void setUnitSize(float f)
  {
    _unit = f;
  }
  
  public void drawIt()
  {
    noStroke();
    
    // vertical slats

    fill(_colVert);

    for (int x = 0; x < _maze.getWidth(); x++)
    {
      for (int y = 0; y < _maze.getHeight() - 1; y++)
      {
        if (_maze.getWallV(x,y))
        {
          float x1 = (float)x*_unit;
          float y1 = (float)y*_unit;
          float x2 = (float)(x+0)*_unit;
          float y2 = (float)(y+1)*_unit;
          //line(x1,y1, x2,y2);

          pushMatrix();
          translate(x1,y1);
          rotateY(-PI/2f);
          quad(0,0, _unit,0, _unit,_unit, 0,_unit);
          popMatrix();
        }
      }
    }
    
    // horiz slats

    fill(_colHoriz);
    
    for (int y = 0; y < _maze.getHeight(); y++)
    {
      for (int x = 0; x < _maze.getWidth() - 1; x++)
      {
        if (_maze.getWallH(y,x))
        {
          float x1 = (float)x*_unit;
          float y1 = (float)y*_unit;
          float x2 = (float)(x+1)*_unit;
          float y2 = (float)(y+0)*_unit;
          // line(x1,y1, x2,y2);
          
          pushMatrix();
          translate(x1,y1);
          rotateX(+PI/2f);
          quad(0,0, _unit,0, _unit,_unit, 0,_unit);
          popMatrix();
          
        }
      }
    }
    
    // floor
    fill(_colFloor);
    float w = (float)(_maze.getWidth()-1)*_unit;
    float h = (float)(_maze.getHeight()-1)*_unit;
    quad(0f,0f, w,0f, w,h, 0f,h);
  }
}

